# Rather than /var/qmail, most things are in /etc/qmail
# Make any other necessary changes here:
# 

%define qmailHome	%{_sysconfdir}/qmail
%define qmailVar	%{_localstatedir}/qmail
%define tcpserverDir	%{_sysconfdir}/tcprules.d

%define qmailAlias	%{qmailHome}/alias
%define qmailControl	%{qmailHome}/control
%define qmailSupervise	%{qmailHome}/supervise
%define qmailUsers	%{qmailHome}/users
%define qmailQueue	%{qmailVar}/queue

%define qmailBin	%{_sbindir}
%define qmailLog	%{_localstatedir}/log/qmail


# Experimental -- some of the patches don't seem to like it
# There will likely be much more work needed here...
%define usedietlibc	0
%define usedjbdns	0


#######################################################################

Name: qmail
Version: 1.03
Release: 2.7.1%{?dist}
Summary: a simple, yet complex, mail transfer agent

Group: System Environment/Daemons
License: Public Domain
URL: http://cr.yp.to/qmail.html
Source0: http://cr.yp.to/software/%{name}-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires(pre): daemontools, ucspi-tcp
BuildRequires: libdomainkeys
Requires: daemontools, ucspi-tcp, stunnel >= 4.05
Provides: mailserver, smtpdaemon, lda
Obsoletes: qmail-maildirmake
Conflicts: postfix


##########################################################################
# Sources, packages, and patches to them
##########################################################################

# qmail-smtpd-auth patch from http://www.fehcom.de/qmail/smtpauth.html
Source2: http://www.fehcom.de/qmail/auth/qmail-smtpd-auth-058_tgz.bin
Source201: qmail-smtpd-auth.patchfix1.patch
Source202: qmail-smtpd-auth.patchfix2.patch

# Allow us to specify an AUTHREQUIRED environment variable via
# tcprules or supervise. If so, rejects any RCPT TOs until the 
# sender has done an SMTP-AUTH
Patch203: qmail.smtpd-authrequired.patch

# But don't offer AUTH as a supported command via ESMTP if no 
# checkpassword command was given on the command line
# Also, check for NOAUTHCRAMMD5 variable and don't offer that
# if that variable is set (ie, when proxying checkpw via POP3)
Patch204: qmail-smtpd-auth.dontauthifnotavailable+crammd5.patch

# Log username in 'ok' response sent out after successful AUTH
Patch205: qmail-1.03.smtpauthlog.patch


# From the reiserfs patch
Source3: syncdir.c

# Use qmailctl from LWQ as a base, although our version is heavily modified
Source4: ftp://ftp.pipeline.com.au/pipeint/sources/linux/WebMail/qmailctl.txt

# Our default runfiles, used by supervise to run and log all the daemons
Source5:  qmail-supervise-log.txt
Source51: qmail-supervise-send.txt
Source52: qmail-supervise-smtpd.txt
Source53: qmail-supervise-qmtpd.txt
Source54: qmail-supervise-qmqpd.txt
Source55: qmail-supervise-pop3d.txt
Source56: qmail-supervise-perm451.txt
Source57: qmail-supervise-pop3d-ssl.txt
Source58: qmail-supervise-smtpd-ssl.txt
Source59: qmail-supervise-smtpd-msa.txt

# The queue-fix utility file, patched for big-todo
Source6: http://www.netmeridian.com/e-huss/queue-fix-1.4.tar.gz
Source66: http://www.qmail.org/queue-fix-todo.patch

# Rotate our logfiles every night at midnight
Source7: qmail.logrotate.cronfile

# Default bounce message text (delete for QMBMF compliance)
Source8: qmail.bouncemessage
Source88: qmail.bouncesubject

# Standard DJB additions (these are placed in separate packages)
Source9: http://cr.yp.to/software/dot-forward-0.71.tar.gz
Source10: http://cr.yp.to/software/fastforward-0.51.tar.gz

# Generic errno patch to fix all of DJB's code, used in some places
# even though we have a qmail-specific one at Patch0
Source11: generic.errno.patch


## Various queue-examination utilities
# qmHandle
Source12: http://osdn.dl.sourceforge.net/sourceforge/qmhandle/qmhandle-1.2.0.tar.gz
# Perl-based autorespond program
Source13: http://www.dcw.ca/autorespond-perl/autorespond-perl-0.1.tar.gz
# QMQtool
Source14: http://jeremy.kister.net/code/qmqtool/qmqtool-current.tgz
 # Patch for the above
Source15: qmqtool.sepcontrol.patch
##

## Qmail greylisting via an external program
## See http://www.jonatkins.com/qgreylist/ for info
Source16: http://www.jonatkins.com/qgreylist/qgreylist-0.3.tar.gz
Source17: qmail.qgreylist.patch
Source171: qmail.greylist
Source172: qmail.greylist-cleanup
Source173: qmail.greylist-cleanup.cronfile
Source174: qmail.greylist-wrapper.sh
##

# Wrapper to log out usernames on successful pop3d connects
Source18: qmail.qmail-pop3d-wrapper.sh

# Wrapper to deal with stunnel for pop3d-ssl and smtp-ssl
Source19: qmail.qmail-stunnel-wrapper.sh
# Default .pem files for hostnames "pop3" and "smtp"
Source191: qmail.pop3d-ssl.pem
Source192: qmail.smtpd-ssl.pem

# A pop3 checkpasswd implementation (for use with smtp-auth servers
# that do not have local access to the pop3 database, for example)
Source20: http://david.acz.org/software/checkpw-pop3-0.51.tar.gz
Patch201: qmail.checkpw-pop3.multisrv.patch


# A wrapper for qmail-smtpd that turns on and off recordio and others
# depending on whether environment variables are set (ie, in tcprules)
Source21: qmail.qmail-smtpd-shim.sh


# Sample config files, custom qmail scripts, and other miscellaneous stuff
Source91: qmail.tcprules-smtpd
Source92: qmail.tcprules-smtpd-msa
Source97: qmail.qmail-purge
Source98: qmail.checkipsmtp


##########################################################################
# "Regular patches"
##########################################################################

# This patch fixes the errno issue in qmail because DJB is too much
# of an ass to admit his software has a bug.
Patch0: http://www.qmail.org/moni.csi.hu/pub/glibc-2.3.1/qmail-1.03.errno.patch


# Fix bug in qmail-local
Patch1: http://www.qmail.org/moni.csi.hu/pub/glibc-2.3.1/qmail-1.03.qmail_local.patch


# Allow qmail to read a control/moreipme file listing alternate IP addresses
# that should be considered "local" (includes the 0.0.0.0 patch)
Patch2: http://www.suspectclass.com/~sgifford/qmail/qmail-1.03-moreipme.patch


# Fix sendmail replacement not recognizing -f bug
Patch3: http://david.acz.org/software/sendmail-flagf.patch


# The reknowned qmail-queue patch...
Patch4: http://www.qmail.org/qmailqueue-patch


# Randomly cycle through the /etc/qmail/control/qmqpservers file
Patch5: http://www.qmail.org/random-qmqpc.patch


# Check that the envelope-sender resolves...
Source60: http://js.hu/package/qmail/qmail-1.03-mfcheck.4.patch
Patch6: qmail-1.03-mfcheck.4.patch.patch


# Allow easy customization of the bounce messages in
#	bouncesubject
#	bouncemessage
#	doublebouncesubject
#	doublebouncemessage
Patch7: http://www.qmail.org/qmail-bouncecontrol-1.03.patch


# Make qmail-smtpd refuse messages with null envelope senders if they have
# more than one envelope-recipient (spamming method)
Patch8: http://www.qcc.ca/~charlesc/software/misc/nullenvsender-recipcount.patch


# Drop doublebounces immediately if .qmail-doublebounceto begins with a blank line
Patch9: http://www.qmail.org/doublebounce-trim.patch


# Allow qmtp to be specified in control/mailroutes
Patch10: http://www.almqvist.net/johan/qmail/qmail-1.03-qmtpc-mailroutes-1.5.patch


# Print all dates in local time instead of GMT
Patch11: ftp://ftp.nlc.net.au/pub/unix/mail/qmail/qmail-date-localtime.patch


# Print the size out after the RETR command when POP3ing. Fixes a Netscape bug
# XXX - NOT APPLIED
Patch12: http://www.qmail.org/netscape-progress.patch


# This patch combines:
#   - log badmailfrom hits to the logfile...
#     http://www.almqvist.net/johan/qmail/qmail-smtpd-log-badmailfrom.patch
#   - add badrcptto functionality
#     http://patch.be/qmail/badrcptto-v1.01.patch
Patch13: qmail-smtpdlog-badmailfrom-badrcptto.combined.patch


# Add ESMTP SIZE capability to qmail-smtpd
Patch14: http://www.fehcom.de/qmail/qmail-smtpd.c.size.diff


# Canonical addresses in log files from qmail-smtp (don't record the CNAME, 
# record what we actually sent it to/as)
Patch15: http://romana.now.ie/software/qmail-canonical.rcpt.patch


# Fix compliance with servers that emminate 5xx errors on connection (per 
# RFC821
# Patch16: http://www.qmail.org/accept-5xx.patch
### Needs further patch
Patch16: accept-5xx.patch-a


## Make qmail more fault-tolerant on ext2/3 and reiserfs
#Patch17: http://www.jedi.claranet.fr/qmail-link-sync.patch


# Make qmtpd respect badmailfrom as well...
Patch18: http://www.almqvist.net/johan/qmail/qmtpd-badmailfrom-1.1.patch


# Make qmail-pop3d respect Maildir++ quotas
Patch19: http://shupp.org/patches/qmail-maildir++.patch


# Patch dns.c to fix buffer that's too small
Patch20: http://www.ckdhr.com/ckd/qmail-103.patch


# Cause condredirect to yield a permanent error if the program exits 100.
Patch21: qmail-condredirect.patch


# Fix hard-coded uid/gids
# From distro at http://untroubled.org/qmail+patches/
# XXX - NOT APPLIED
Patch22: qmail-1.03-autouidgid.patch


# Fix qmail-pop3d to only report the total number of non-deleted messages in the "STAT" command.
Patch23: http://www.dataloss.nl/software/patches/qmail-pop3d-stat.patch


# Allow concurrency above 255
Patch24: http://www.qmail.org/big-concurrency.patch


# The big-todo and ext-todo combo patch. My god, it actually works down here!!
Patch25: http://home.graffiti.net/feizhou/big-ext-todo-20030101
# Or perhaps the big-todo only, then...
Patch2511: http://qmail.oc1.mirrors.redwire.net/big-todo.103.patch


# Now that that's applied, apply the install-path patch for autouids
Patch26: qmail-1.03-install-path-big-todo.patch
Patch2611: qmail-1.03-install-path.patch


# Now, make patch23 actually work!
# XXX - NOT APPLIED
#Patch27: qmail-autouids.patch


# An errno patch for queue-fix v.1.4
Patch28: queue-fix-1.4.errno.patch


# Take all the chown commands out of install.c (prevents from dying when building as non-root)
# (use if patches 25/26 are used)
Patch29: qmail-1.03.TODO.install-chown.patch  
Patch2911: qmail-1.03.install-chown.patch


# Remove the auto uid determination lines from makefile and insert a hard-coded
# auto_uids.c file with the LWQ-standard uids and gids
Patch30: qmail-1.03.auto_uids.c.patch


# Make the qmail-qstat shell script not give out an error if there's nothing in queue/todo/
# (use if patches 25/26 are used)
Patch31: qmail-qstat.TODO.no-errors.patch 
Patch3111: qmail-qstat.no-errors.patch


# Fix a few random bugs to make qmail more ISO-C compliant
# XXX - NOT APPLIED
Patch32: http://www.jcb-sc.com/qmail/patches/qmail-isoc.patch


# Allow qmail-smtpd to accept bare linefeeds, because DJB is a punk
Patch33: http://www.arctic.org/~dean/patches/qmail-0.95-liberal-lf.patch


# Comply with RFC2821 by skipping MX servers that don't greet with 220 [by Matthias Andree] 
# XXX - NOT APPLIED
Patch34: http://www-dt.e-technik.uni-dortmund.de/~ma/qmail/patch-qmail-1.03-rfc2821.diff

# Tweak qmail-local to fork processes from .qmail files using /bin/dash instead of /bin/sh
Patch35: qmail-1.03.qmail-local-ash.patch


# Patch to enable Sender Policy Framework (see http://spf.pobox.com/)
Source44: http://www.saout.de/misc/spf/qmail-spf-rc5.patch
 # (patch to fix above)
Patch44: qmail-spf-rc5.patch.TODO-DK-others.patch
Patch441: qmail-spf-rc5.patch.Makefile.patch
Patch442: qmail.spf.openspf

# Add RCPTCHECK patch from http://www.soffian.org/downloads/qmail/qmail-smtpd-doc.html
Source45: http://www.soffian.org/downloads/qmail/qmail-smtpd.patch
Patch45: qmail-smtpd.patch.patch

# Add HELOHOST environment variable for the use of the procs forked above
Patch451: qmail.smtpd-heloenv.patch
# Add jc pipe patch for returning error messages by the procs forked above
Patch452: qmail.smtpd-rcptcheck-custom-error.patch


# Re-read concurrencylocal and concurrencyremote files when receiving a 
# HUP
Patch46: http://js.hu/package/qmail/qmail-1.03-reread-concurrency.2.patch


# Modify qmail-smtpd to send 500 errors when encountering an unrecognized
# SMTP command, instead of a 502 error
Source47: http://homepages.tesco.net./~J.deBoynePollard/Softwares/qmail/smtpd-502-to-500.patch
Source471: smtpd-502-to-500.patch.patch


# qmail-smtpd-chk-user from http://www.interazioni.it/opensource/chkuser/
# 
# Source48: http://www.interazioni.it/opensource/chkuser/download/archives/chkuser-2.0.8b-release.tar.gz


# Modify qmail-smtpd to reject and close the connection whenever it receives
# any HTTP-like commands (GET, POST, HEAD) -- these are used by HTTP
# proxies masquarading as SMTP servers
Patch48: http://homepages.tesco.net./~J.deBoynePollard/Softwares/qmail/smtpd-no-http.patch


# Remove old qmail workaround for BIND 4.9.4 and below that causes too many 
# DNS requests for anything newer than it
Patch49: http://homepages.tesco.net./~J.deBoynePollard/Softwares/qmail/any-to-cname.patch


# All for customer perm error messages to be sent back...
Patch50: https://no-way.org/uploads/6/29/qmail-queue-custom-error.netqmail-1.05.patch
Patch51: https://no-way.org/uploads/6/28/qmail-queue-custom-error.patch

# Allow bounces to be forced to go through a specific server... to keep
# possible blowback confined to a single box.
Patch52: qmail.bounceroutes-after-qmtp-mailroutes.patch

# Enable a SRS (Sender-Rewriting Scheme)
Patch53: http://qmail.org/qmail-srs-0.3.patch


# Enable DomainKeys support (see patch for details)
Source62: http://www.qmail.org/qmail-1.03-dk-0.53.patch
# Use for no big-todo
Patch621: qmail-1.03-dk-0.53.patch.TODO.patch
Patch622: qmail-1.03-dk-0.53.patch.patch
## This needs the domainkeys.sf.net stuff to compile!
## Hence the BuildRequires libdomainkey


# Modify qmail-remote to bind to different local ip addresses depending on the
# domain part in the sender argument
Source70: http://www.rno-consultores.com/mail/qmail/qmail-1.03_outgoingips.patch
Patch70: qmail-1.03_outgoingips.patch.patch
Patch71: qmail-1.03_outgoingips.patch.for_qmtp_as_well


# Provides the ability to make a copy of each email that flows through the system.
# This is done using the QUEUE_EXTRA code. See FAQ #8.2
Source80: http://www.inter7.com/qmailtap/qmail-tap.diff
Source81: http://www.inter7.com/qmailtap/INSTALL.tap
Source82: http://www.inter7.com/qmailtap/README.tap
Patch80: qmail-tap.diff.TODO.patch
Patch81: qmail-tap.diff.SPF.patch


# If djbdns-1.05 is waiting in the build directory for us, after we make
# qmail-{remote,smtpd} the first time, rm and make it again using the
# djbdns resolving library, for speed and robustness
Patch99: qmail.djbdns.patch


# Add a per-IP connection limit to destination IPs.
#
Patch100: http://www.coyotetechnical.com/software/patches/qmail-send-concurrencyperip.patch
Patch101: qmail-send-concurrencyperip.patch.patch


# Reset the number of bytes received when a sender sends the RSET command.
# Otherwise, message size totals will keep accumulating until we hit the
# databytes max value.
Patch103: qmail-smtpd.rset_databytes.patch

# Have qmail-queue put a X-Originating-IP: header in the message
# if TCPREMOTEIP is set. Helps with AOL and other recipients.
# See: http://marc.theaimsgroup.com/?l=qmail&m=115092235402886&w=2
Patch104: http://jeremy.kister.net/code/qmail-1.03.originip-field.patch.new


# Log all attempted "RCPT TO"s in qmail-smtpd, along with the eventual
# disposition of a message (451, 553, etc...). Important for debugging
# when RCPTCHECK is not being called or is not used.
Patch105: qmail-1.03.logging-base.patch
Patch106: qmail-1.03.logging.patch
Patch107: qmail-1.03.smtp-rcptcheck_inc_proto.patch

# Reject any futher RCPT TO attempts once a badrcptto has been seen in
# that connection. This happens at the DATA though, to prevent false
# bounces for specific senders
Patch108: qmail-1.03.smtpd-badrcptto-seen.patch


# Exit 0 from qmail-popup in normal cases (if given a QUIT or if authentication
# via checkpassword and qmail-pop3d went ok). This clears up the "status 256" 
# messages you've seen forever in the pop3 log files
Patch109: qmail-1.03.popup-exit0.patch


# Add holdremote and holdlocal files for control. When one is set, qmail-send
# won't do remote (or local) deliveries. Read in when qmail-send is HUPed
Patch110: http://www.leverton.org/blosxom/Software/Projects/Qmail/qmail-hold-1.03.pat.gz
# Make it work with concurrencyip and the doublebounce patch
Patch111: qmail-hold.patch.patch


# TLS support for incoming and outgoing SMTP traffic
Patch120: http://inoa.net/qmail-tls/netqmail-1.05-tls-20070408.patch
Patch121: http://inoa.net/qmail-tls/netqmail-1.05-tls-20070408.remote.patch
Patch122: http://inoa.net/qmail-tls/netqmail-1.05-tls-20070408.smtpd.patch
Patch123: http://inoa.net/qmail-tls/netqmail-1.05-tls-20070408.control.patch
Patch124: http://inoa.net/qmail-tls/netqmail-1.05-tls-20070408.misc.patch


###############################################################################
%description
qmail is a secure, reliable, efficient, simple message transfer agent. It 
is designed for typical Internet-connected UNIX hosts as a replacement for
sendmail. It natively uses Maildirs instead of the standard mbox format,
making it more ideal for use with NFS-shared mailbox storage among hosts.

The following patches are among those included in this package:

 - errno patch fix for glibc 2.3.1
 - qmail-1.03.qmail_local.patch
 - qmail-0.0.0.0.patch
 - qmail-1.03-moreipme.patch
 - sendmail-flagf.patch
 - qmailqueue-patch
 - random-qmqpc.patch
 - qmail-1.03-mfcheck.4.patch (check that env. sender resolves)
 - qmail-bouncecontrol-1.03.patch (custom bounce messages)
 - nullenvsender-recipcount.patch
 - doublebounce-trim.patch
 - qmail-1.03-qmtpc-mailroutes-1.5.patch
 - qmail-date-localtime.patch
 - qmail-smtpdlog-badmailfrom-badrcptto.combined.patch
 - qmail-smtpd.c.size.diff (ESMTP SIZE)
 - qmail-canonical.rcpt.patch
 - accept-5xx.patch
 - qmtpd-badmailfrom-1.1.patch
 - qmail-maildir++.patch
 - qmail-103.patch (patch dns.c to fix a buffer that's too small for AOL)
 - qmail-condredirect.patch (yields a permanent error if the program exits 100)
 - qmail-pop3d-stat.patch 
	(Fix qmail-pop3d to only report the total number of 
	non-deleted messages in the "STAT" command)
 - big-concurrency.patch
 - qmail-1.03-install-path.patch
 - qmail-1.03.auto_uids.c.patch
 - qmail-qstat.no-errors.patch
 - qmail-smtpd-auth-0.5.7
 - qmail-1.03-reread-concurrency.2.patch
 - qmail-local-tab.patch
 - qmail-spf-rc5.patch
 - smtpd-502-to-500.patch
 - smtp-no-http.patch
 - any-to-cname.patch
 - qmail-queue-custom-error.patch (netqmail version)
 - qmail-1.03_outgoingips.patch
 - qmail-1.03_outgoingips.patch.for_qmtp_as_well
 - qmail-pop3d logging
 - big-ext-todo-20030101
 - qmail-1.03-dk-0.53.patch (DomainKeys support - use BEFORE simscan scanners)
 - qmail-tap patch
 - RCPTCHECK patch
	(see http://www.soffian.org/downloads/qmail/qmail-smtpd-doc.html)
 - a VERY modified version of qgreylist
	(see http://www.jonatkins.com/page/software/qgreylist/)
 - a perm tempfailer configuration (perm451)
 - qmail.smtpd-authrequired.patch
 - qmail.smtpd-heloenv.patch
 - qmail.smtpd-rcptcheck-custom-error.patch
 - qmail-1.03.qmail-local-ash.patch
 - qmail-send-concurrencyperip.patch
 - qmail-smtpd.rset_databytes.patch
 - qmail-1.03.originip-field.patch
 - qmail-1.03.logging.patch
 - qmail-smtpd-auth.dontauthifnotavailable.patch
 - qmail-1.03.smtp-rcptcheck_inc_proto.patch
 - qmail-1.03.smtpd-badrcptto-seen.patch
 - qmail-1.03.popup-exit0.patch
 - qmail-hold-1.03.patch

###############################################################################
%package perm451
Group: System Environment/Daemons
Summary: a configuration for a permanent 451 daemon
Requires: qmail = %{version}-%{release}
        
%description perm451
perm451 acts as a fake SMTP server that simply gives a 451 response to
all attempmted deliveries. You should install this config if you want 
a server to give an "under maintenance" message when you've taken down
the main smtp server for maintenance, or if you are using this as a false
MX record of higher priority.


###############################################################################
%package pop3d
Group: System Environment/Daemons
Summary: a Post Office Protocol v3 (POP3) daemon for qmail
Requires: qmail = %{version}-%{release}, checkpassword
        
%description pop3d
qmail-pop3d provides a POP3/APOP/POP3S-compliant POP3 server that uses the
checkpassword interface to authenticate users, then serves mail out
of the Maildir in the user's home directory. If stunnel is installed, the
server can also accept connections over SSL.

You should install this package if you want to serve mail via POP3.


###############################################################################
%package qmqpd
Group: System Environment/Daemons
Summary: a Quick Mail Queueing Protocol (QMQP) daemon for qmail
Requires: qmail = %{version}-%{release}
        
%description qmqpd
QMQP is a protocol for one qmail client to queue mail remotely to another 
qmail server rather than queueing it locally. This service is intended to 
be used between (e.g.) several computers in a qmail cluster and should not 
be accessible by untrusted machines.

You should install this package if you want to accept QMQP connections 
from other machines.


###############################################################################
%package qmtpd
Group: System Environment/Daemons
Summary: a Quick Mail Transfer Protocol (QMTP) daemon for qmail
Requires: qmail = %{version}-%{release}
        
%description qmtpd
The Quick Mail Transfer Protocol (QMTP) is a replacement for the
Simple Mail Transfer Protocol (SMTP). QMTP eliminates any need for
end-of-line scanning between hosts with the same end-of-line
convention. It features automatic pipelining and chunking, 8-bit
transmission, prior declaration of the message size, and efficient
batching. It is designed to be very easy to implement.

You should install this package if you want to accept QMTP connections 
from other mail servers.


###############################################################################
%package smtpd
Group: System Environment/Daemons
Summary: a Simple Mail Transfer Protocol (SMTP) daemon for qmail
Requires: qmail = %{version}-%{release}
        
%description smtpd
qmail-smtpd receives mail messages via the Simple Mail Transfer Protocol 
(SMTP) and invokes qmail-queue to deposit them into the outgoing queue.

It accepts ESMTP, can perform SMTP-Authentication, PIPELINING, Size 
rejection, and many other nifty features. If stunnel is available, it can 
also accept SMTP connections over SSL.

You should install this package if you want to accept mail from other mail 
servers on the Internet.


###############################################################################
%package greylist 
Group: System Environment/Daemons
Summary: a perl-based greylister for qmail
Requires: qmail = %{version}-%{release}
        
%description greylist
A perl-based greylister for use with qmail. It will greylist any class-C
space it sees communicating with the mail server for the first time for
a configurable length of time, to discourage connections from machines
that are not running legitimate mail servers.

It also includes tarpitting and full logging of the attempted senders
and recipients.


###############################################################################
%package fastforward
Group: System Environment/Applications
Summary: qmail extensions to forward mail according to an aliases-style database
Requires: qmail = %{version}-%{release}
        
%description fastforward
fastforward handles qmail forwarding according to a cdb database. It can
create forwarding databases from a sendmail-style /etc/aliases or from
user-oriented virtual-domain tables.

fastforward supports external mailing lists, stored in a binary format
for fast access. It has a tool to convert sendmail-style include files
into binary lists.

Install this package if you need to use existing sendmail-style aliases
files in your migration to qmail.


###############################################################################
%package dotforward
Group: System Environment/Applications
Summary: read a .forward files under qmail
Requires: qmail = %{version}-%{release}
Obsoletes: qmail-dot-forward

%description dotforward
dot-forward reads sendmail's .forward files under qmail. You can run it in 
the qmail startup script to support all your existing .forward files 
automatically. Individual users can switch to the .qmail mechanism at 
their leisure.

dot-forward supports forwarding, program deliveries, and comments. It does 
not support file deliveries or :include:. (However, it recognizes file 
delivery attempts, and defers delivery to give you a chance to set up a 
.qmail file.)

Install this package if you need to use existing sendmail-style .forward
files in your migration to qmail.


###############################################################################
%package sendmail
Group: System Environment/Applications
Summary: a qmail-compatible version of the sendmail injection program
Requires: qmail = %{version}-%{release}
Provides: sendmail

%description sendmail
A replacement for sendmail that uses qmail-send as its queue. Install this
package if you have programs -- likely -- that expect to be able to feed messages
by calling the /usr/sbin/sendmail program directly.


###############################################################################
%package autorespond
Group: System Environment/Daemons
Summary: an perl-based autoresponder for qmail
Requires: qmail, perl
AutoReqProv: No

%description autorespond
A perl-based autoresponder for use with qmail and qmailadmin. It includes 
a compatibility mode for use with vpopmail's default autoresponder.


###############################################################################
###############################################################################
%prep
###############################################################################

%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3
%patch4 -p1
%patch5

%patch50 -p1

cp -f %{SOURCE60} qmail-1.03-mfcheck.4.patch
%patch6 -p0
patch -p1 < qmail-1.03-mfcheck.4.patch

%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1

#%patch12
%patch13
%patch14 -p2
%patch15

#%patch17
%patch16 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21
#%patch22 -p1
%patch23
%patch24 -p1
%patch25 -p1

%patch26 -p1
%patch29
%patch30
%patch31
#%patch32 -p1
#%patch33
#%patch34
%patch35
%patch46 -p1


cp -f %{SOURCE47} smtpd-502-to-500.patch
  patch -p0 smtpd-502-to-500.patch < %{SOURCE471}
  patch -p1 < smtpd-502-to-500.patch

%patch48 -p1
%patch49 -p1

## Not yet compatible -- in development
## %patch52 -b .bounceroutes

## Not yet compatible -- in development
## This patch may be replaced by the vpopmail-fd 
## code once that is installed
## %patch53 -p1

#### DOMAINKEYS ########################################
# Needs DomainKeys libs available (domainkeys.sf.net)
cp -f %{SOURCE62} qmail-1.03-dk-0.53.patch
%patch621
%patch622
# Remove direct spec of libdir... it's lib64 on x86_64 machines
sed -i "s#/usr/lib/#%{_libdir}/#" qmail-1.03-dk-0.53.patch
patch -p1 < qmail-1.03-dk-0.53.patch


#### SMTP-AUTH #########################################
# Source2 is the qmail-smtpd-auth patch. Move the config files into the main build
# directory.
  tar -xzvf %{SOURCE2} 
  patch Makefile.patch < %{SOURCE201}
  patch qmail-smtpd.c.patch < %{SOURCE202}

  patch < Makefile.patch
  patch < qmail-smtpd.c.patch
  patch < qmail-smtpd.8.patch
  patch < TARGETS.patch


#### SPF PATCHES #######################################
cp -f %{SOURCE44} qmail-spf-rc5.patch
patch -p0 qmail-spf-rc5.patch < %{PATCH44}
patch -p1 < qmail-spf-rc5.patch
%patch441
%patch442

########################################################

cp -f %{SOURCE45} qmail-smtpd.patch
%patch45 -p0
patch -p1 < qmail-smtpd.patch
%patch451
%patch452


%patch203
%patch204
%patch205


cp -f %{SOURCE70} qmail-1.03_outgoingips.patch
%patch70 -p0
patch -p1 < qmail-1.03_outgoingips.patch
%patch71


cp -f %{SOURCE80} qmail-tap.diff
%patch80 -p0
%patch81 -p0
patch -p1 < qmail-tap.diff

# Dynamically determine the concurrency-limit in conf-spawn
FDS=`ulimit -n`
let SPAWNLIMIT='(FDS-6)/2'
echo "$SPAWNLIMIT" > conf-spawn

# Set our special qmail home directory (normally /var/qmail, we use /etc/qmail)
echo %{qmailHome} > conf-qmail

cp -f %{SOURCE3} .

# per-IP concurrency limit
cp -f %{PATCH100} qmail-send-concurrencyperip.patch
%patch101 -p0
patch -p1 < qmail-send-concurrencyperip.patch


# reset databytes value
%patch103 -p0

# Add X-Originating-IP header
%patch104 -p0

# Add qmail-smtpd logging
%patch105	-b .logging-base
%patch106	-b .logging
%patch107	-b .smtp-rcptcheck_inc_proto
%patch108	-b .badrcptto-seen
%patch109	-b .popup-exit0

# Needs to go before double-bounce patch
gunzip -c %{PATCH110} > qmail-hold-1.03.pat
%patch111 -p0
patch -p0 < qmail-hold-1.03.pat

# Add TLS support (and pray)
#%patch121 -p1


#### Additional changes that aren't done via patch
#

# Change mfpatch to use proper extended SMTP error code
%{__perl} -pi -e 's/sender domain must exist \(#5.7.1\)/sender domain must exist (#5.1.8)/' qmail-smtpd.c
%{__perl} -pi -e 's/DNS temporary failure \(#4.3.0\)/DNS temporary failure (#4.1.8)/' qmail-smtpd.c


####


#### Prepare additional SOURCEs ######################

# dot-forward
%setup -D -q -T -a 9
# fast-forward
%setup -D -q -T -a 10
# queue-fix
%setup -D -q -T -a 6
# checkpw-pop3
%setup -D -q -T -a 20

#### Prepare additional DJB qmail packages ######################

pushd dot-forward-0.71/
 echo %{qmailHome} > conf-qmail
 patch -p0 < %{SOURCE11}
 cp -f ../qmail.c qmail.c
 cp -f ../qmail.h qmail.h
popd

pushd fastforward-0.51/
 echo %{qmailHome} > conf-qmail
 patch -p0 < %{SOURCE11}
 cp -f ../qmail.c qmail.c
 cp -f ../qmail.h qmail.h
popd


#### Prepare non-invasive additional packages ###############

mkdir qmHandle
pushd qmHandle
 tar -xzvf %{SOURCE12}
popd

mkdir autorespond-perl/
pushd autorespond-perl/                   
 cp -f %{SOURCE13} .
 tar -xzvf *.tar.gz
popd

# source 6
%patch28
pushd queue-fix-1.4/
  patch -p1 < %{SOURCE66}
popd

tar -xzvf %{SOURCE14}
pushd qmqtool-1.09/
  patch -p0 < %{SOURCE15}
popd

tar -xzvf %{SOURCE16}
pushd qgreylist/
  patch -p0 < %{SOURCE17}
popd


###############################################################################
%build
###############################################################################
%if %{?usedietlibc}
  echo "diet gcc %{optflags}"			> conf-cc
  echo "diet gcc %{optflags} -static -s"	> conf-ld
%endif


make compile makelib
./compile syncdir.c 
./makelib libsyncdir.a syncdir.o 
make it man

%if %{?usedjbdns}
# Check for djbdns-1.05 in the builddir, if so, use qmail+djbdns patch
if [ -f ../djbdns-1.05/qmail_txt.a ]; then

  rm -f qmail-smtpd qmail-remote

  # remove dns.lib, dns.o, and error.a from qmail-remote and smtpd
  # add in qmail_txt.a and unix.a from djbdns
  patch < %{PATCH99} 	

  make it
fi
%endif


pushd queue-fix-1.4/
  %if %{?usedietlibc}
      echo "diet gcc %{optflags}"		> conf-cc
      echo "diet gcc %{optflags} -static -s"	> conf-ld
  %endif
  make
popd

pushd dot-forward-0.71/
  %if %{?usedietlibc}
      echo "diet gcc %{optflags}"		> conf-cc
      echo "diet gcc %{optflags} -static -s"	> conf-ld
  %endif
  make
popd

pushd fastforward-0.51/
  %if %{?usedietlibc}
      echo "diet gcc %{optflags}"		> conf-cc
      echo "diet gcc %{optflags} -static -s"	> conf-ld
  %endif
  make
popd

pushd checkpw-pop3-0.51/
  %if %{?usedietlibc}
      echo "diet gcc %{optflags}"		> conf-cc
      echo "diet gcc %{optflags} -static -s"	> conf-ld
  %endif
  patch -p0 < %{PATCH201}
  make
popd


###############################################################################
%install
###############################################################################
rm -fR %{buildroot}

# First, make our entire directory structure, then populate with files...

install -d %{buildroot}%{_bindir}
install -d %{buildroot}%{_sbindir}
install -d %{buildroot}%{_localstatedir}
install -d %{buildroot}%{_mandir}
install -d %{buildroot}%{_libdir}
install -d %{buildroot}%{_initrddir}
install -d %{buildroot}%{_sysconfdir}/cron.d
install -d %{buildroot}%{_sysconfdir}/sysconfig
install -d %{buildroot}%{tcpserverDir}
install -d %{buildroot}%{qmailSupervise}

# Do our thing...
./install "%{buildroot}%{qmailHome}"
./instcheck "%{buildroot}%{qmailHome}"


# Move the queue into /var/qmail/queue
install -d %{buildroot}%{qmailVar}
if [ -d "%{buildroot}%{qmailHome}/queue" ] ; then
    mv -f %{buildroot}%{qmailHome}/queue %{buildroot}%{qmailQueue}
    ln -s %{qmailQueue} %{buildroot}%{qmailHome}/queue
fi

# install qmail-dk (DomainKeys support)
install -m 755 qmail-dk %{buildroot}%{qmailBin}


###
# Clean up after qmail (and DJB's pig-headedness...)
###

# We use our own boot-scripts
rm -fR %{buildroot}%{qmailHome}/boot

# Delete duplicated documentation
rm -fR %{buildroot}%{qmailHome}/doc

# Moving man pages to system man directory
rm -fR %{buildroot}%{qmailHome}/man/cat*
mv -f %{buildroot}%{qmailHome}/man/* %{buildroot}%{_mandir}/
rmdir %{buildroot}%{qmailHome}/man

# Install man pages for add-ons
install -m 644 qmail-dk.8 %{buildroot}%{_mandir}/man8/

# Moving binaries to system bin directory (/usr/sbin)
# We *could* use libexec here, but sbin is much simpler...
mv -f %{buildroot}%{qmailHome}/bin/* %{buildroot}%{qmailBin}
rmdir %{buildroot}%{qmailHome}/bin
ln -s %{qmailBin} %{buildroot}%{qmailHome}/bin

# Copy the sendmail shims to the right places
ln -s %{qmailBin}/sendmail %{buildroot}%{_bindir}/sendmail
ln -s %{qmailBin}/sendmail %{buildroot}%{_libdir}/sendmail


# Install our nightly crontab
install -m 644 %{SOURCE7} %{buildroot}%{_sysconfdir}/cron.d/qmail.logrotate


# Install our SysV script...
install -m 755 %{SOURCE4} %{buildroot}%{_initrddir}/qmail
ln -s %{_initrddir}/qmail %{buildroot}%{_sbindir}/qmailctl

# Install qmail-pop3d logging wrapper
install -m 755 %{SOURCE18} %{buildroot}%{qmailBin}/qmail-pop3d-wrapper.sh


# Install stunnel wrapper (for all SSL services)
install -m 755 %{SOURCE19} %{buildroot}%{qmailBin}/qmail-stunnel-wrapper.sh

# Install our default pem certificates; they're set to simply the
# "pop3" and "smtp" hostnames. Use openssl's "make pem" to replace.
install -m 644 %{SOURCE191} %{buildroot}%{qmailControl}/pop3d-ssl.pem
install -m 644 %{SOURCE192} %{buildroot}%{qmailControl}/smtpd-ssl.pem

# Install qmail-smtpd shim wrapper
install -m 755 %{SOURCE21} %{buildroot}%{qmailBin}/qmail-smtpd-shim.sh


# Copy over queue-fix
install -m 755 queue-fix-1.4/queue-fix %{buildroot}%{qmailBin}/

# Copy over qmHandle
install -m 755 qmHandle/qmHandle %{buildroot}%{qmailBin}/qmHandle
 install qmHandle/HISTORY qmHandle.HISTORY
 install qmHandle/README qmHandle.README

# Copy over qmqtool
 install -m 755 qmqtool-1.09/qmqtool %{buildroot}%{qmailBin}/qmqtool
    for THIS in ChangeLog FAQ README
    do
	install qmqtool-1.09/$THIS qmqtool.$THIS
    done


# Copy over qgreylist
 install -m 755 %{SOURCE171} %{buildroot}%{qmailBin}/greylist
 install -m 755 %{SOURCE172} %{buildroot}%{qmailBin}/greylist-cleanup
 install -m 755 %{SOURCE174} %{buildroot}%{qmailBin}/qmail-greylist-wrapper.sh

 install -m 644 %{SOURCE173} %{buildroot}%{_sysconfdir}/cron.d/qmail.greylist
 install -m 755 -d %{buildroot}%{qmailVar}/greylist
 # Make our ip directories, hashed by first octet
 for THIS in `%{__perl} -e "print join(' ', (0 .. 255))"`
 do
    install -m 755 -d %{buildroot}%{qmailVar}/greylist/$THIS
 done


# Copy over dot-forward
 pushd dot-forward-0.71/
  install -m 755 dot-forward %{buildroot}%{qmailBin}/dot-forward
  ln -s %{qmailBin}/dot-forward %{buildroot}%{_bindir}/dot-forward
  install -m 644 dot-forward.1 %{buildroot}%{_mandir}/man1/

  for THIS in BLURB CHANGES FILES INSTALL README VERSION THANKS TODO
  do
	install "$THIS" "../dot-forward.$THIS"
  done
popd

# Copy over checkpw-pop3
pushd checkpw-pop3-0.51/
  install -m 755 checkpw-pop3 %{buildroot}%{qmailBin}/checkpw-pop3

  for THIS in CHANGES INSTALL LICENSE README
  do
      install "$THIS" "../checkpw-pop3.$THIS"
  done
popd


# Copy over fastforward
pushd fastforward-0.51/
  for THIS in fastforward newaliases newinclude printforward printmaillist setforward setmaillist
  do
	install -m 755 "$THIS" %{buildroot}%{qmailBin}/
	install "$THIS.1" %{buildroot}%{_mandir}/man1/
  done
popd


# Copy over autorespond (the perl version)
install -m 755 autorespond-perl/autorespond-perl.pl %{buildroot}%{qmailBin}/autorespond
pushd %{buildroot}%{qmailBin}
  ln -s %{qmailBin}/autorespond %{buildroot}%{_bindir}/autorespond
popd


# Copy some misc. documentation to the source root...
install queue-fix-1.4/README README.queuefix
install queue-fix-1.4/CHANGES CHANGES.queuefix

install %{SOURCE81} INSTALL.tap
install %{SOURCE82} README.tap



## TCPSERVER stuff

# Create supervise support structure (run and log/run) and populate all of our files

pushd %{buildroot}
 for THIS in send smtpd qmtpd qmqpd pop3d pop3d-ssl smtpd-ssl smtpd-msa perm451; do

	install -d "%{buildroot}%{qmailSupervise}/qmail-$THIS/log"
	install -m 755 "%{_sourcedir}/qmail-supervise-$THIS.txt" "%{buildroot}%{qmailSupervise}/qmail-$THIS/run"

	install -d "%{buildroot}%{qmailLog}/$THIS"
	install -m 755 "%{SOURCE5}" "%{buildroot}%{qmailSupervise}/qmail-$THIS/log/run"
	echo -n "%{qmailLog}/$THIS" >> "%{buildroot}%{qmailSupervise}/qmail-$THIS/log/run"

 done
popd

# Copy over other scripts
install -m 755 %{SOURCE97} %{buildroot}%{qmailBin}/qmail-purge
install -m 755 %{SOURCE98} %{buildroot}%{qmailBin}/checkipsmtp



## Add lots of default config files..

# Customized bounce message and subject
install -m 644 %{SOURCE8} %{buildroot}%{qmailControl}/bouncemessage
install -m 644 %{SOURCE88} %{buildroot}%{qmailControl}/bouncesubject

# Account that bounce messages are sent from
 echo MAILER-DAEMON	> %{buildroot}%{qmailControl}/bouncefrom

# Max number of qmail-local and qmail-remote delivery processes
 echo 80		> %{buildroot}%{qmailControl}/concurrencylocal
 echo 100		> %{buildroot}%{qmailControl}/concurrencyremote

# Max number of incoming SMTP connections (via LWQ run scripts)
 echo 100		> %{buildroot}%{qmailControl}/concurrencyincoming

# Max size of DATA in an incoming SMTP connection at 40MB; 0=unlimited
 echo 41943040		> %{buildroot}%{qmailControl}/databytes

# Account to send double bounces to ("" = toss double bounces w/o queueing them)
 echo ""		> %{buildroot}%{qmailControl}/doublebounceto

# Max time a message stays in the queue
# echo 3600		> %{buildroot}%{qmailControl}/queuelifetime

# Set timeouts for incoming and outgoing SMTP connections
 echo 120		> %{buildroot}%{qmailControl}/timeoutremote
 echo 120		> %{buildroot}%{qmailControl}/timeoutconnect
 echo 120		> %{buildroot}%{qmailControl}/timeoutsmtpd

# Check that the envelope sender's domain resolves (antispam check)
 echo 1			> %{buildroot}%{qmailControl}/mfcheck

# Set defaults for SPF (Sender Policy Framework) see http://www.saout.de/misc/spf/
 echo 2						> %{buildroot}%{qmailControl}/spfbehavior

# Rules applied prior to SPF lookup
 echo "include:spf.trusted-forwarder.org"	> %{buildroot}%{qmailControl}/spfrules

# Rules applied afterwords, if no SPF rules are found
 echo "a/24 mx/24 ptr"				> %{buildroot}%{qmailControl}/spfguess

# Default extended explanation, if not overridden by the domain
 echo "Denied by Sender Policy Framework (see http://www.openspf.org/)" > %{buildroot}%{qmailControl}/spfexp



# Create default aliasempty file specifying a Maildir
 echo "./Maildir/"	> %{buildroot}%{qmailControl}/aliasempty


# Create default user entries
 echo "."		> %{buildroot}%{qmailUsers}/assign


# Build compatability links under /var/qmail
install -d %{buildroot}%{qmailVar}
pushd %{buildroot}%{qmailVar}
  rm -fR alias control users bin man
  ln -s %{qmailAlias}	alias
  ln -s %{qmailControl}	control
  ln -s %{qmailLog}	log
  ln -s %{qmailUsers}	users
popd

# Create default tcpserver files...
pushd %{buildroot}%{tcpserverDir}
  install -m 644 %{SOURCE91}	  qmail-smtpd
  install -m 644 %{SOURCE92}	  qmail-smtpd-msa
  echo ":allow"			> qmail-pop3d
  echo ":deny"			> qmail-qmqpd
  echo ":allow"			> qmail-qmtpd
popd

# Add environment variables to /etc/sysconfig
echo 'QMAILROOT="%{qmailHome}"'		>> %{buildroot}%{_sysconfdir}/sysconfig/qmail
echo 'QMAILBIN="%{qmailBin}"'		>> %{buildroot}%{_sysconfdir}/sysconfig/qmail
echo 'QMAILSVC="%{qmailSupervise}"'	>> %{buildroot}%{_sysconfdir}/sysconfig/qmail

# Creating sample files that will be replaced later...

touch %{buildroot}%{qmailControl}/defaultdomain
touch %{buildroot}%{qmailControl}/defaulthost
touch %{buildroot}%{qmailControl}/plusdomain
touch %{buildroot}%{qmailControl}/locals
touch %{buildroot}%{qmailControl}/rcpthosts
touch %{buildroot}%{qmailControl}/envnoathost
touch %{buildroot}%{qmailControl}/bouncehost
touch %{buildroot}%{qmailControl}/doublebouncehost

touch %{buildroot}%{qmailAlias}/.qmail-postmaster
touch %{buildroot}%{qmailAlias}/.qmail-root
touch %{buildroot}%{qmailAlias}/.qmail-abuse
touch %{buildroot}%{qmailAlias}/.qmail-noc
touch %{buildroot}%{qmailAlias}/.qmail-security
touch %{buildroot}%{qmailAlias}/.qmail-devnull
touch %{buildroot}%{qmailAlias}/.qmail-mailer-daemon



###############################################################################
%pre
if [ "$1" -eq 1 ]; then
  # Main (first) install -- check for users and add them

   /usr/sbin/groupadd -g 2107 -o nofiles	|| :
   /usr/sbin/groupadd -g 2108 -o qmail		|| :

   /usr/sbin/useradd -c "qmail Alias"  -d "%{qmailAlias}" -g nofiles -M -u 7790 -s /bin/true alias  2> /dev/null
   /usr/sbin/useradd -c "qmail Daemon" -d "%{qmailHome}"  -g nofiles -M -u 7791 -s /bin/true qmaild 2> /dev/null
   /usr/sbin/useradd -c "qmail Logger" -d "%{qmailHome}"  -g nofiles -M -u 7792 -s /bin/true qmaill 2> /dev/null
   /usr/sbin/useradd -c "qmail Passwd" -d "%{qmailHome}"  -g nofiles -M -u 7793 -s /bin/true qmailp 2> /dev/null
   /usr/sbin/useradd -c "qmail Queue"  -d "%{qmailHome}"  -g qmail   -M -u 7794 -s /bin/true qmailq 2> /dev/null
   /usr/sbin/useradd -c "qmail Remote" -d "%{qmailHome}"  -g qmail   -M -u 7795 -s /bin/true qmailr 2> /dev/null
   /usr/sbin/useradd -c "qmail Send"   -d "%{qmailHome}"  -g qmail   -M -u 7796 -s /bin/true qmails 2> /dev/null

fi


###############################################################################
%post
# Only do this on installs, not upgrades
if [ "$1" -eq 1 ]; then

   if [ ! -d "%{_sysconfdir}/skel/Maildir" ] ; then
	%{qmailBin}/maildirmake %{_sysconfdir}/skel/Maildir
   fi

   if [ ! -f "%{qmailControl}/me" ] ; then

	defaultHostname=`uname -n`
	defaultHost=`uname -n | %{__perl} -ne "s/\..*$//g;" -e "print lc"`
	defaultDomain=`uname -n | %{__perl} -ne "s/.*\.([a-z0-9-]+\.[a-z]+)$/\1/i;" -e "print lc"`

	echo "* Configuring qmail with a default domain of $defaultDomain"

	echo "$defaultHostname" > "%{qmailControl}/me"
	echo "$defaultDomain" > "%{qmailControl}/defaultdomain"
	echo "$defaultDomain" > "%{qmailControl}/defaulthost"
	echo "$defaultDomain" > "%{qmailControl}/envnoathost"
	echo "$defaultDomain" > "%{qmailControl}/bouncehost"
	echo "$defaultDomain" > "%{qmailControl}/doublebouncehost"
	echo "$defaultDomain" > "%{qmailControl}/plusdomain"

	echo "$defaultDomain" >> "%{qmailControl}/rcpthosts"
	echo "localhost
localhost.localdomain
$defaultHost
$defaultHostname"	>> %{qmailControl}/locals

  	# Create some decent mail defaults...
	echo "&postmaster@$defaultDomain"		> %{qmailAlias}/.qmail-postmaster
	echo "&postmaster"				> %{qmailAlias}/.qmail-root
	echo "&postmaster"				> %{qmailAlias}/.qmail-abuse
	echo "&postmaster"				> %{qmailAlias}/.qmail-noc
	echo "&postmaster"				> %{qmailAlias}/.qmail-security
	echo "# throw messages away undelivered"	> %{qmailAlias}/.qmail-devnull
	echo "# throw messages away undelivered"	> %{qmailAlias}/.qmail-mailer-daemon

   fi
fi

# Shouldn't be anything wrong, but do a fix anyway (this will
# add the fifo for us, since we can't package it anyway).
%{qmailBin}/queue-fix %{qmailQueue} 2>&1 >/dev/null

# Check for too few semaphores in kernel
if [ -f "/proc/sys/kernel/sem" ] ; then
   SEMS=`cat /proc/sys/kernel/sem | cut -f 1`
   [ -n "$SEMS" ] || SEMS="0"
   if [ "$SEMS" -lt 256 ]; then
	echo "* You may need to increase your kernel sempahores from $SEMS to 256"
	echo "* Read %{_docdir}/%{name}-%{version}/README.concurrencyperip for info"
   fi
fi

# Load our cdb files for the first time...
  /sbin/chkconfig --add qmail
  /sbin/service qmail cdb					>/dev/null	|| :

# Add things to svscan here...
  /sbin/service svscan add "%{qmailSupervise}/qmail-send"	>/dev/null	|| :


###############################################################################
%preun
if [ "$1" -eq 0 ] ; then

	for THIS in "smtpd smtpd-ssl smtpd-msa qmtpd qmqpd pop3d pop3d-ssl send"
	do
	   /sbin/service qmail del "$THIS"  >/dev/null 2>&1 || :
	   /sbin/service svscan del "$THIS" >/dev/null 2>&1 || :
	done

	/sbin/service qmail stop
	/sbin/chkconfig --del qmail

	/sbin/service svscan condrestart    >/dev/null 2>&1 || :

	/usr/sbin/userdel alias		|| :
	/usr/sbin/userdel qmaild	|| :
	/usr/sbin/userdel qmaill	|| :
	/usr/sbin/userdel qmailp	|| :
	/usr/sbin/userdel qmailq	|| :
	/usr/sbin/userdel qmailr	|| :
	/usr/sbin/userdel qmails	|| :

	/usr/sbin/groupdel qmail	|| :
	/usr/sbin/groupdel nofiles	|| :

	# Remove trigger fifo file
	rm -f %{qmailQueue}/lock/*

	# Remove hostname file if we're really removing qmail
	rm -f %{qmailControl}/me

fi

%postun
if [ "$1" -eq 0 ] ; then

	/usr/sbin/userdel alias		|| :
	/usr/sbin/userdel qmaild	|| :
	/usr/sbin/userdel qmaill	|| :
	/usr/sbin/userdel qmailp	|| :
	/usr/sbin/userdel qmailq	|| :
	/usr/sbin/userdel qmailr	|| :
	/usr/sbin/userdel qmails	|| :

	/usr/sbin/groupdel qmail	|| :
	/usr/sbin/groupdel nofiles	|| :

fi


###############################################################################
%preun greylist
if [ "$1" -eq 0 ]; then
    # Remove greylist files
    rm -fR %{qmailVar}/greylist/*/*
    rm -f  %{qmailVar}/greylist/.lastcleanup
fi


###############################################################################
%clean
rm -fR  %{buildroot}


###############################################################################
%files
###############################################################################
%defattr(-,root,root)

##########################################
 # Documentation
 %doc BLURB* CHANGES* FAQ FILES* INSTALL* INTERNALS PIC* README*
 %doc REMOVE* SECURITY TEST* THANKS THOUGHTS TODO UPGRADE VERSION
 %doc EXTTODO*

 %{_mandir}/man1/bouncesaying.1.gz
 %{_mandir}/man1/condredirect.1.gz
 %{_mandir}/man1/except.1.gz
 %{_mandir}/man1/forward.1.gz
 %{_mandir}/man1/maildir2mbox.1.gz
 %{_mandir}/man1/maildirmake.1.gz
 %{_mandir}/man1/maildirwatch.1.gz
 %{_mandir}/man1/mailsubj.1.gz
 %{_mandir}/man1/preline.1.gz
 %{_mandir}/man1/qbiff.1.gz
 %{_mandir}/man1/qreceipt.1.gz
 %{_mandir}/man1/tcp-env.1.gz
 %{_mandir}/man5/addresses.5.gz
 %{_mandir}/man5/dot-qmail.5.gz
 %{_mandir}/man5/envelopes.5.gz
 %{_mandir}/man5/maildir.5.gz
 %{_mandir}/man5/mbox.5.gz
 %{_mandir}/man5/qmail-control.5.gz
 %{_mandir}/man5/qmail-header.5.gz
 %{_mandir}/man5/qmail-log.5.gz
 %{_mandir}/man5/qmail-users.5.gz
 %{_mandir}/man5/tcp-environ.5.gz
 %{_mandir}/man7/forgeries.7.gz
 %{_mandir}/man7/qmail-limits.7.gz
 %{_mandir}/man7/qmail.7.gz
 %{_mandir}/man8/qmail-clean.8.gz
 %{_mandir}/man8/qmail-command.8.gz
 %{_mandir}/man8/qmail-dk.8.gz
 %{_mandir}/man8/qmail-getpw.8.gz
 %{_mandir}/man8/qmail-inject.8.gz
 %{_mandir}/man8/qmail-local.8.gz
 %{_mandir}/man8/qmail-lspawn.8.gz
 %{_mandir}/man8/qmail-newmrh.8.gz
 %{_mandir}/man8/qmail-newu.8.gz
 %{_mandir}/man8/qmail-pw2u.8.gz
 %{_mandir}/man8/qmail-qmqpc.8.gz
 %{_mandir}/man8/qmail-qread.8.gz
 %{_mandir}/man8/qmail-qstat.8.gz
 %{_mandir}/man8/qmail-queue.8.gz
 %{_mandir}/man8/qmail-remote.8.gz
 %{_mandir}/man8/qmail-rspawn.8.gz
 %{_mandir}/man8/qmail-send.8.gz
 %{_mandir}/man8/qmail-showctl.8.gz
 %{_mandir}/man8/qmail-start.8.gz
 %{_mandir}/man8/qmail-tcpok.8.gz
 %{_mandir}/man8/qmail-tcpto.8.gz
 %{_mandir}/man8/splogger.8.gz

 # Documentation for various packages in the main package
 %doc qmHandle.*
 %doc qmqtool.*
 %doc checkpw-pop3.*


## Note, checkpw-pop3 is in the main package (instead of pop3) because
## it can also be used by qmail-smtpd for SMTP authentication


##########################################
 # General common files
 %config(noreplace) %{_sysconfdir}/sysconfig/qmail
 %config %{_sysconfdir}/cron.d/qmail.logrotate
 %{_initrddir}/qmail

 %dir %{qmailHome}
      %{qmailHome}/queue
      %{qmailHome}/bin
 %dir %{qmailVar}
      %{qmailVar}/alias
      %{qmailVar}/control
      %{qmailVar}/log
      %{qmailVar}/users
 %dir %{qmailSupervise}
 %dir %{qmailLog}


 # Files relating to qmail-send as a service...
 %config(noreplace)	 %{qmailSupervise}/qmail-send
 %attr(755,qmaill,qmail) %{qmailLog}/send


##########################################
 # Alias dir (and .qmail files in it) should be uid alias:nofiles
 %attr(6755,alias,nofiles) %dir %{qmailAlias}
 %attr(644,alias,nofiles)  %config(noreplace) %{qmailAlias}/.qmail-*


##########################################
 # Control and Users directories (and files)... group-writable
 # so that scripts and other things in gid qmail (like vpopmail) can
 # adjust qmail settings
 %attr(775,root,qmail) %config(noreplace) %{qmailControl}
 %attr(775,root,qmail) %config(noreplace) %{qmailUsers}


##########################################
 # /var/qmail/queue -- but each directory has its own permissions
 ##########################################
 %attr(750,qmailq,qmail) %dir %{qmailQueue}
  %attr(700,qmails,qmail) %{qmailQueue}/bounce
  %attr(700,qmails,qmail) %{qmailQueue}/info
  %attr(700,qmails,qmail) %{qmailQueue}/local
  %attr(700,qmails,qmail) %{qmailQueue}/remote

  %attr(700,qmailq,qmail) %dir %{qmailQueue}/pid
  %attr(700,qmailq,qmail) %dir %{qmailQueue}/intd
  %attr(750,qmailq,qmail) %dir %{qmailQueue}/mess
  %attr(750,qmailq,qmail) %dir %{qmailQueue}/todo

  %attr(750,qmailq,qmail) %dir %{qmailQueue}/intd/*
  %attr(750,qmailq,qmail) %dir %{qmailQueue}/mess/*
  %attr(750,qmailq,qmail) %dir %{qmailQueue}/todo/*

  %attr(750,qmailq,qmail) %dir %{qmailQueue}/lock
  %attr(600,qmails,qmail)      %{qmailQueue}/lock/sendmutex
  %attr(644,qmailr,qmail)      %{qmailQueue}/lock/tcpto


# Binaries
%attr(755,root,root) %{qmailBin}/checkpw-pop3
%attr(755,root,root) %{qmailBin}/bouncesaying
%attr(755,root,root) %{qmailBin}/condredirect
%attr(755,root,root) %{qmailBin}/datemail
%attr(755,root,root) %{qmailBin}/elq
%attr(755,root,root) %{qmailBin}/except
%attr(755,root,root) %{qmailBin}/forward
%attr(755,root,root) %{qmailBin}/qmail-purge
%attr(755,root,root) %{qmailBin}/maildir2mbox
%attr(755,root,root) %{qmailBin}/maildirmake
%attr(755,root,root) %{qmailBin}/maildirwatch
%attr(755,root,root) %{qmailBin}/mailsubj
%attr(755,root,root) %{qmailBin}/pinq
%attr(755,root,root) %{qmailBin}/predate
%attr(755,root,root) %{qmailBin}/preline
%attr(755,root,root) %{qmailBin}/qail
%attr(755,root,root) %{qmailBin}/qbiff
%attr(711,root,root) %{qmailBin}/qmail-clean
%attr(711,root,root) %{qmailBin}/qmail-getpw
%attr(755,root,root) %{qmailBin}/qmail-inject
%attr(711,root,root) %{qmailBin}/qmail-local
%attr(700,root,root) %{qmailBin}/qmail-lspawn
%attr(755,root,root) %{qmailBin}/qmail-newmrh
%attr(755,root,root) %{qmailBin}/qmail-newu
%attr(711,root,root) %{qmailBin}/qmail-pw2u
%attr(755,root,root) %{qmailBin}/qmail-qmqpc
%attr(755,root,root) %{qmailBin}/qmail-qread
%attr(755,root,root) %{qmailBin}/qmail-qstat
%attr(6711,qmailq,qmail) %{qmailBin}/qmail-queue
%attr(711,root,root) %{qmailBin}/qmail-remote
%attr(711,root,root) %{qmailBin}/qmail-rspawn
%attr(711,root,root) %{qmailBin}/qmail-send
%attr(755,root,root) %{qmailBin}/qmail-showctl
%attr(700,root,root) %{qmailBin}/qmail-start
%attr(755,root,root) %{qmailBin}/qmail-stunnel-wrapper.sh
%attr(755,root,root) %{qmailBin}/qmail-tcpok
%attr(755,root,root) %{qmailBin}/qmail-tcpto
%attr(755,root,root) %{qmailBin}/qmail-todo
%attr(755,root,root) %{qmailBin}/qmailctl
%attr(755,root,root) %{qmailBin}/qmHandle
%attr(755,root,root) %{qmailBin}/qmqtool
%attr(755,root,root) %{qmailBin}/qreceipt
%attr(755,root,root) %{qmailBin}/qsmhook
%attr(755,root,root) %{qmailBin}/queue-fix
%attr(711,root,root) %{qmailBin}/splogger
%attr(755,root,root) %{qmailBin}/tcp-env



%files perm451
%config(noreplace)	%{qmailSupervise}/qmail-perm451
%attr(755,qmaill,qmail) %{qmailLog}/perm451


%files pop3d
%{_mandir}/man8/qmail-popup.8.gz
%{_mandir}/man8/qmail-pop3d.8.gz
%{qmailBin}/qmail-pop3d
%{qmailBin}/qmail-pop3d-wrapper.sh
%attr(711,root,root)	%{qmailBin}/qmail-popup
%config(noreplace)	%{tcpserverDir}/qmail-pop3d
%config(noreplace)	%{qmailSupervise}/qmail-pop3d
%config(noreplace)	%{qmailSupervise}/qmail-pop3d-ssl
%attr(440,root,qmail)	%config(noreplace) %{qmailControl}/pop3d-ssl.pem
%attr(755,qmaill,qmail) %{qmailLog}/pop3d
%attr(755,qmaill,qmail) %{qmailLog}/pop3d-ssl


%files qmqpd
%{_mandir}/man8/qmail-qmqpd.8.gz
%{qmailBin}/qmail-qmqpd
%config(noreplace)	%{tcpserverDir}/qmail-qmqpd
%config(noreplace)	%{qmailSupervise}/qmail-qmqpd
%attr(755,qmaill,qmail) %{qmailLog}/qmqpd


%files qmtpd
%{_mandir}/man8/qmail-qmtpd.8.gz
%{qmailBin}/qmail-qmtpd
%config(noreplace)	%{tcpserverDir}/qmail-qmtpd
%config(noreplace)	%{qmailSupervise}/qmail-qmtpd
%attr(755,qmaill,qmail) %{qmailLog}/qmtpd


%files smtpd
%{_mandir}/man8/qmail-smtpd.8.gz
%{qmailBin}/checkipsmtp
%{qmailBin}/qmail-dk
%{qmailBin}/qmail-smtpd
%{qmailBin}/qmail-smtpd-shim.sh
%config(noreplace)	%{tcpserverDir}/qmail-smtpd
%config(noreplace)	%{tcpserverDir}/qmail-smtpd-msa
%config(noreplace)	%{qmailSupervise}/qmail-smtpd
%config(noreplace)	%{qmailSupervise}/qmail-smtpd-msa
%config(noreplace)	%{qmailSupervise}/qmail-smtpd-ssl
%attr(440,root,qmail)	%config(noreplace) %{qmailControl}/smtpd-ssl.pem
%attr(755,qmaill,qmail) %{qmailLog}/smtpd
%attr(755,qmaill,qmail) %{qmailLog}/smtpd-msa
%attr(755,qmaill,qmail) %{qmailLog}/smtpd-ssl


################################################
%files fastforward
%defattr(-,root,root)
%doc	fastforward-0.51/ALIASES fastforward-0.51/BLURB fastforward-0.51/CHANGES fastforward-0.51/README fastforward-0.51/THANKS

%{qmailBin}/fastforward
%{qmailBin}/printforward
%{qmailBin}/setforward
%{qmailBin}/newaliases
%{qmailBin}/printmaillist
%{qmailBin}/setmaillist
%{qmailBin}/newinclude
%{_mandir}/man1/fastforward.1.gz
%{_mandir}/man1/printforward.1.gz
%{_mandir}/man1/setforward.1.gz
%{_mandir}/man1/newaliases.1.gz
%{_mandir}/man1/printmaillist.1.gz
%{_mandir}/man1/setmaillist.1.gz
%{_mandir}/man1/newinclude.1.gz


%files dotforward
%defattr(-,root,root)
%doc	dot-forward-0.71/BLURB dot-forward-0.71/CHANGES dot-forward-0.71/INSTALL dot-forward-0.71/README dot-forward-0.71/THANKS

%{qmailBin}/dot-forward
%{_bindir}/dot-forward
%{_mandir}/man1/dot-forward.1.gz


%files greylist
%defattr(-,root,root)
%doc 	qgreylist/README

%attr(755,qmaild,qmail) %{qmailVar}/greylist
%config(noreplace)	%{_sysconfdir}/cron.d/qmail.greylist
%{qmailBin}/greylist
%{qmailBin}/greylist-cleanup
%{qmailBin}/qmail-greylist-wrapper.sh


%files sendmail
%defattr(-,root,root)
%doc SENDMAIL
%{qmailBin}/sendmail
%{_libdir}/sendmail
%{_bindir}/sendmail


%files autorespond
%defattr(-,root,root)
%doc autorespond-perl/README
%{qmailBin}/autorespond
%{_bindir}/autorespond


###############################################################################
%changelog
* Mon Sep 30 2013 Japheth Cleaver <cleaver@terabithia.org> 1.03-2.7.1
- rebuild
- tighten patches
- replace /bin/ash with /bin/dash

* Thu Jun 5 2008 Japheth Cleaver <cleaver@redwire.net> 1.03-2.6
- add files for incoming/outgoing TLS support 
  via netqmail-1.05-tls-20070408.patch
- rebuild for fc9
- bugfix with libdomain qmail-dk patch, don't specify /usr/lib/ on x86_64

* Sat May 10 2008 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-2.5.2
- add qmail-hold-1.03.patch

* Wed Mar 05 2008 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-2.5.1
- bugfixes in qmail-smtpd_custom_error parsing

* Wed Dec 19 2007 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-2.5
- rebuild and bump version number
- add qmail-1.03.smtp-rcptcheck_inc_proto patch. We can now tell when
  a connection is coming in via ESMTPA

* Thu Sep 27 2007 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-2.4.9.4
- minor spec cleanup: delete qmail user/groups post-uninstall, not pre
- update qmail-maildir++ patch from vpopmail


* Tue Sep 11 2007 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-2.4.9.2
- add smtpauthlog patch
- check for NOCRAMMD5 in qmail-smtpd and don't offer CRAM-MD5 as an 
  auth option if set (prevents needless duplicate authentication with
  checkpw-pop3 or another checkpassword that can't use CRAM-MD5).


* Tue Aug 28 2007 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-2.4.9
- check (and fix on run) the proper number of semaphors in the qmail-send 
  run script -- needed by concurrencyperip patch
- strengthen checking for a checkpassword program in smtpd scripts
- don't provide the AUTH extension when checkpassword isn't available
- check both AUTHREQUIRED and REQUIREAUTH variables like other patches
- bugfix: remove nulls in recips logged via qmail-1.03.logging-base.patch
- change SPF deny URL from spf.pobox.com to www.openspf.org


* Sun Aug 19 2007 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-2.4.8.1
- allow multiple servers to be specified with checkpw-pop3
- qmail-pop3d package now requires only a checkpassword package of some type,
  and determines dynamically if vpopmail should be used
- qmail-popup now exits 0 unless something abnormal happened


* Fri Aug 17 2007 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-2.4.7
- add spamtrapping when a badrcptto is encountered (all mail in that 
  session will be rejected)
- print all valid recipients, not just the last one, when logging 
  message disposition
- fix extended SMTP error codes when the sender domain doesn't resolve


* Wed Aug 15 2007 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-2.4.6
- add X-Originating-IP header in qmail-queue
- add qmail-smtpd logging patch based on Kyle Wheeler's work
- significantly rewritten smtpd supervise run scripts
- remove perm451 daemon and use rblsmtpd within the run script


* Wed Jun 06 2007 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-2.4.3
- update qmail-smtpd-auth patch to 0.58


* Fri May 25 2007 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-2.4.2
- error-checking and robustness updates to qmailctl
- now use /var/service/blah/down as a flag when starting and stopping services.
  /etc/init.d/qmail will set svscan not to start it automatically on boot. The 
  services will be flagged to begin when /etc/init.d/qmail start is called (later in
  the boot process).
- update qmail-smtpd run scripts to use qmail-smtpd-shim.sh (whoops)
- remove info about POP-before-SMTP from supervise files, that patch is no
  longer applied to our ucspi-tcp package.
- modify SPF error message generated to use openspf.com
- patch so that RSET resets the accumulated databytes amount when
  size-restrictions are enabled in qmail-smtpd


* Sun May 6 2007 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-2.4.1
- roll back djbdns+qmail due to potential memory issues

* Fri May 4 2007 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-2.4
- integrate djbdns+qmail patches with SPF compatibility


* Thu Mar 08 2007 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-2.3
- replace sbl-xbl.spamhaus.org with zen on smtpd and smtpd-ssl scripts
  but NOT smtpd-msa (port 587)
- increase softlimit on smtpd to 50M
- add qmail-smtpd-shim.sh to allow for logging on a per-IP basis and 
  modify instructions in qmail-smtpd*/run to accomodate


* Tue Jan 16 2007 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-2.2
- add qmail-send-concurrencyperip patch
- add check to %post for kernel.sem slots to be 256 or higher


* Tue Dec 19 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-2.1
- increase default # logs to keep from 25 to 40 for high
  volume servers
- remove ordb.org from rblsmtpd samples due to rbl shutdown
- add SRS patch from Marcelo Coelho, but not applied


* Fri Nov 10 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-2
- add missing manual for qmail-dk.8
- reach limit of release "2" :)


* Tue Oct 17 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.9.9.9
- include bounceroutes patch, but not applied due to incompatibility
  with qmtproutes

* Thu Sep 28 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.9.9.8.9
- add qmail.smtpd-rcptcheck-custom-error.patch to allow $RCPTCHECK programs
  to send back specific error messages when permanently or temporarily 
  rejecting recipients.
- patch qmail-local to fork from .qmail with /bin/ash instead of /bin/sh


* Wed Aug 02 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.9.9.8.7
- remove unneeded docdirs in sub-packages
- add qmail-tcpok to qmailctl's flush command
- misc initscript tweaks


* Mon Jun 20 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.9.9.8.5
- move qmail-newu and qmail-newmrh back to main package. allows cdb manipulation
  on machines that aren't running qmail-smtpd (ie, vpopmail pop3-only boxes)
- HELOENV patch was inserting a ptr instead of the value; fixed
- add additional exit strings to RCPTCHECK patch in smtpd
- rename qmail-dot-forward package to qmail-dotforward
- minor spec updates


* Mon Jun 12 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.9.9.8.3a
- tighten up permissions (many things were chgrp qmail that didn't need to be)
- break out fastforward and dot-forward into separate packages
- break out perm451, pop3d, qmqpd, qmtpd, and smtpd as well


* Wed Jun 07 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.9.9.8.2
- add experimental dietlibc support based on work at http://alq.sourceforge.net/
- misc bugfixes to ensure qmail can operate w/o vpopmail
- add a Maildir to /etc/skel on install
- add control/timeoutgreysmtpd config for greylister, perm451
- break sendmail replacement into separate qmail-sendmail package,
  remove Conflicts statement from main package, and move to -sendmail's Provides
- break greylist into separate package
- spec cleanup


* Mon Jun 05 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.9.9.8
- more specfile alterations in preparation for package split
- directories in /etc/qmail/supervise/ no longer sticky (not needed)
- added checkpw-pop3


* Fri Jun 02 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.9.9.7
- add HELOHOST patch to provide HELO'd data to processes fired off 
  during a RCPTCHECK
- roll maildirmake back into main package -- no longer conflicts with 
  courier-imap's version.
- raise softlimit limit for smtpd from 20M to 30M to account for larger
  memory footprint of vrctpcheck-real when it's reading in a large
  badmailfromdomains list
- begin work to break into separate packages for each daemon


* Wed May 31 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.9.9.5
- reduce speedycgi timeouts on greylist and perm451 to 120 seconds to
  prevent connections left hanging with tcpserver


* Fri May 12 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.9.9.4
- buglets in scriptlets
- modify speedycgi settings on greylist and perm451
- qmailctl: add check for fd-qstat (from vpopmail) and run it
  when doing a stat check


* Fri May 05 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.9.9.3
- PreReq -> Requires(pre)
- now Provides: lda


* Wed May 03 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.9.9.2
- increase softlimit for perm451
- add MSRBL.org to list of rbls
- add qmail-purge script to automate purgeing a queue
- add qmail-remove script to automate removing messages with strings in them


* Thu Apr 27 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.9.9.1
- add perm451, a permanent SMTPD tempfailer, for use during maintenance
  or on a "fake" backup MX server to ward off spammers
- minor enhancements to greylister
- more spec file cleanup


* Wed Mar 28 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.9.9
- 'qmailctl stop xxxx' leaves supervise process for /log up,
  use 'svscan stop qmail-xxxxd' to stop those as well
- softlimit, multilog, setuidgid, and svc are in /sbin now instead of /usr/sbin
- clean up spec file for FC5 compatibility
- remove install -o user -g group, unneeded during install script


* Wed Dec 14 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.9.8
- 'qmailctl add/del blah' now calls ->
	'/etc/init.d/svscan add/del /etc/qmail/supervise/qmail-blahd'
- General specfile cleanups
- Minor change to default bounce message, use bouncesubject from file
- Multilog max log size is 16MB, not 20MB
- Add daemontools, ucspi-tcp as Prereq's
- Move checkipsmtp here from ucspi-tcp package


* Thu Dec 01 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.9.7
- Initscript bugfixes
- Create qmail-pop3d-ssl and qmail-smtpd-ssl services using new 
  qmail-stunnel-wrapper.sh hack
- Add service for qmail-smtpd-msa running on port 587
- Add stunnel >= 4.05 dependency
- Patch to require SMTP-AUTH in order to accept *any* mail when
  AUTHREQ environment variable is present

* Mon Nov 21 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.9.6
- SPF patch re-added
- Autorespond broken into separate package for better Require
- Built for MySQL 5

* Fri Nov 04 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.9.5
- qmail-dk patch applied for DomainKeys support, now requires
  libdomainkeys files to be installed to build
- Add cron entry to rotate logs daily
- Default multilog to 15 logs of max 20MB
- Specfile cleanups

* Fri Nov 04 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.9.4
- Rewritten greylist for efficiency,
  /var/qmail/greylist/* now hashed by first octet
- Add greylist-cleanup as a cron in /etc/cron.d/
- Include liberal-lf patch but not applied, fixcrio used instead

* Tue Oct 25 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.9.3
- Specfile bugfixes for /var/qmail/todo and intd directories

* Fri Oct 21 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.9.2
- Break out the default SORBS rbls in supervise/qmail-smtpd and
  add rabl.nuclearelephant.com
- Commenting out SPF patch for now - had never actually been applied
  but conflicted with several other patches
- Minor specfile cleanup

* Wed Oct 05 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.9.1
- Integrate qmail-tap patches from Inter7

* Fri Sep 23 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.9
- Integrate big-ext-todo patch (along with big-todo patch for queue-fix)
- Typo in name of maildirmake package

* Wed Sep 21 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.8.1
- Add logging of username on successful POP3 connection via multilog
- Implement qgreylist, add /var/qmail/greylist as a directory
  (patched to use the NOGREYLIST tcprules variable instead of a
  whitelist directory.
- Add info for RCPTCHECK variable to sample tcprules file (sample
  program included with vpopmail rpm)
- Remove default .qmail-MAILER-DAEMON from alias directory. qmail-local 
  lowercases users before checking for these.

* Thu Sep 15 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.8
- Add qmail-1.03_outgoingips.patch

* Tue Jul 12 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.7
- Break maildirmake into its own package
- Add qmail-queue-custom-error.netqmail-1.05.patch
- Bugfix: Copy new qmail.h patch to dot-foward and fastforward dirs

* Thu May 20 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.6.2
- Add a default smtp tcprules file to tempfail connections from
  servers that don't resolve to anything

* Tue May 3 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.6.1
- Fix dupe smtp_size call in qmail-smtpd-auth patch

* Thu Apr 21 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.6
- Add three patches from http://homepages.tesco.net./~J.deBoynePollard/Softwares/qmail/

* Tue Apr 12 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.5
- Update to qmail-smtpd-auth-0.5.6 (from vpopmail-5.4.10)

* Thu Mar 17 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.4
- Re-modify hard-coded gids... oops.

* Fri Mar 11 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.3
- Add qmqtool to distribution
- Replace 0.0.0.0 patch with moreipme
- Re-modify hard-coded gids... oops.

* Fri Dec 31 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.2
- Add alias to /usr/sbin/autorespond at /usr/bin/autorespond 
  (to fix qmailadmin problems)

* Wed Dec 22 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1.1
- Add SBL-XBL RBL SpamHaus list, and remove osirusoft
- Modify hard-coded gids to match LWQ standards (nofiles and qmail
  were switched)

* Fri Sep 3 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-1
- Bump version number, general spec-file cleanup
- Move maildirmake.orig to separate maildirmake-qmail

* Thu Jul 28 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-0.96
- Add RCPTCHECK patch
- Add reread-concurrency patch
- Update mfcheck patch to v4

* Mon Mar 22 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-0.94
- Added autorespond-perl to this package

* Thu Mar 11 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-0.93
- Removed cmd5chkpassword (superfluous)
- General spec file cleanup

* Thu Mar 4 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-0.92
- ~alias file fixes
- Better determiniation of default domain

* Fri Feb 27 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-0.91
- Add ucspi-tcp as a requirement
- Verified with Vpopmail 5.4.2

* Tue Feb 17 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-0.9
- Remove reiserfs sync patch, causing tempfails writing to queue.
- Spec desc fixes, added patch files, though not implemented
- Verified with Vpopmail 5.4.1

* Wed Feb 04 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-0.8
- Update to qmail-smtpd-auth-0.4.2 for compat with Vpopmail 5.4.0
- Minor spec fixes. Use qmailctl for adding and removing.

* Mon Feb 02 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-0.6
- Build on Fedora Core 1
- Add qmHandle

* Thu Jan 15 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-0.4
- Include dot-forward and fastforward packages
- Edit qmail-send supervise script to add dot-forward functionality

* Wed Jan 14 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-0.3
- Fix qmail-smtpd and other supervise scripts
- Change scripts to use ash instead of /bin/sh (faster, less memory)

* Thu Jan 07 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-0.2
- Rename maildirmake to maildirmake.orig in preparation for installing
  courier-imap.

* Thu Nov 20 2003 Japheth Cleaver <cleaver@rohan.sdsu.edu> 1.03-0.1
- Created new spec file
- Install TONS of patches
- Change qmail's home dir to /etc/qmail from /var/qmail
- Install binaries into /usr/sbin instead of /etc/qmail/bin
